import java.io.BufferedReader;
import java.io.FileReader;

public class Main {
        
    public static void main(String[] args) {
        
        BufferedReader file_input = null;
        String line = new String();
        char event;
        int i, itm, iId, stm, sId, gId;
        
        // Check command line arguments
        if (args.length < 1) {
            System.out.println("\n Usage: <program_name> <input-file>\n");
            System.exit(0);
        }
        
        try {
            
            // Open input file
            file_input = new BufferedReader(new FileReader( args[0] ));
            
            if( file_input == null ) {
                System.out.println("\n Could not open file:" + args[1] + "\n");
                System.exit(1);
            }
            
            // Read input file line-by-line and handle the events
            int numRead = 0;
            String[] params = null;
            
            while ((line = file_input.readLine()) != null) {
                if(line.equals("")) continue;
                
                // Uncomment the line below when in debug mode
                //System.out.println("\n Event: \"" + line + "\"");
                
                switch(line.charAt(0)) {
                        // Insert_Info event
                    case 'I':
                        params = line.split(" ");
                        event = params[0].charAt(0);
                        itm = Integer.parseInt(params[1]);
                        iId = Integer.parseInt(params[2]);
                        for (i=3; (gId = Integer.parseInt(params[i]))!=-1; i++) {
                            // your code...
                            ;
                        }
                        // your code...
                        break;
                        
                        // Subscriber_Registration event
                    case 'S':
                        params = line.split(" ");
                        event = params[0].charAt(0);
                        stm = Integer.parseInt(params[1]);
                        sId = Integer.parseInt(params[2]);
                        for (i=3; (gId = Integer.parseInt(params[i]))!=-1; i++) {
                            // your code...
                            ;
                        }
                        // your code...
                        break;
                        
		     // Prune event
                    case 'R':
                        params = line.split(" ");
                        event = params[0].charAt(0);
                        itm = Integer.parseInt(params[1]);
                        
                        // your code...
                        break;

                        // Consume event
                    case 'C':
                        params = line.split(" ");
                        event = params[0].charAt(0);
                        sId = Integer.parseInt(params[1]);
                        
                        // your code...
                        break;
                        
                        // Delete_Subsciber event
                    case 'D':
                        params = line.split(" ");
                        event = params[0].charAt(0);
                        sId = Integer.parseInt(params[1]);
                        
                        // your code...
                        break;
                        
                        // Print event
                    case 'P':
                        params = line.split(" ");
                        event = params[0].charAt(0);
                        
                        // your code...
                        break;
                        
                        // Ignore everything else
                    default:
                        // Uncomment the line below when in debug mode
                        //System.out.println("\n Ignoring line:\"" + line + " \"");
                        
                        break;
                }
            }
            
            file_input.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
    }
    
}
