#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define LINE_LENGTH 1000000
#define MG 10

int main(int argc, char** argv)
{
	FILE *fp = NULL;
	char *token,*search=" ";
	char line[LINE_LENGTH], event;
	int itm,iId,stm,sId;
	int gId;

	/* Check command line arguments */
	if( argc < 2 )
	{
		printf("\n Usage: %s <input-file>\n", argv[0]);
		return(EXIT_FAILURE);
	}

	/* Open input file */
	if( ( fp = fopen(argv[1], "r") ) == NULL )
	{
		printf("\n Could not open file: %s\n", argv[1]);
		return(EXIT_FAILURE);
	}

	/* Read input file line-by-line and handle the events */
	while( fgets(line, LINE_LENGTH, fp) != NULL )
	{
		/* Uncomment the line below when in debug mode */
		//printf("\n Event: %s ", line);
		switch(line[0])
		{
		/* Insert_Info event */
			case 'I':
				sscanf(line, "%c %d %d", &event, &itm, &iId);
				printf("\nEvent : %c itm : %d iId : %d ",event,itm,iId);
				token=strtok(line,search);	
				token=strtok(NULL,search);
				token=strtok(NULL,search);
				while ((gId=atoi(token=strtok(NULL,search))) != -1){
					printf ("gId : %d ",gId);
					/* your code... */
				}
				
		                /* your code... */
	                
			break;
	
		/* Subscriber_Registration event */
			case 'S':		
		                sscanf(line, "%c %d %d", &event, &stm, &sId);
				printf("\nEvent : %c stm : %d sId : %d ",event,stm,sId);
				token=strtok(line,search);	
				token=strtok(NULL,search);
				token=strtok(NULL,search);
				while ((gId=atoi(token=strtok(NULL,search))) != -1){
					printf ("gId : %d ",gId);
					/* your code... */				
				}
				/* your code... */
			break;

		/* Prune event */
			case 'R':
				sscanf(line, "%c %d", &event,&itm);
				printf("\nEvent : %c itm : %d",event,itm);
				/* your code... */
			break;
	
		/* Consume event */
			case 'C':
				sscanf(line, "%c %d", &event, &sId);
				printf("\nEvent : %c sId : %d",event,sId);
				/* your code... */
			break;
	
		/* Delete_Subsciber event */
			case 'D':
				sscanf(line, "%c %d", &event, &sId);
				printf("\nEvent : %c sId : %d",event,sId);
				/* your code... */
			break;
	
		/* Print event */
			case 'P':
				sscanf(line, "%c", &event);
				printf("\nEvent : %c ",event);
				/* your code... */
			break;
	
		/* Ignore everything else */
			default:
		/* Uncomment the line below when in debug mode */
			/* printf("\n Ignoring line: %s", line); */
	
			break;
		}
	}
	printf("\n");
	return (EXIT_SUCCESS);
}

